# -*- coding: utf-8 -*-
#
# ApplicationIntegrationServer - PostgreSQL Example Plugin
#
# Copyright (c) 2014 - 2017 MailStore Software GmbH
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# http://initd.org/psycopg/
# https://pypi.python.org/pypi/psycopg2
# https://wiki.postgresql.org/wiki/Psycopg2_Tutorial
import psycopg2


class Plugin:
    def __init__(self):
        self.db_host = "172.20.13.22"
        self.db_user = "admin"
        self.db_pass = "password"
        self.db_database = "appintusers"

    def http_authentication(self, username, password):
        return username == self.db_user and password == self.db_pass

    def list_(self, _):
        db_connection = psycopg2.connect(host=self.db_host, user=self.db_user,
                                         password=self.db_pass, database=self.db_database)
        cursor = db_connection.cursor()
        cursor.execute('SELECT "userName","fullName","emailAddresses" from users')
        user_list = list()
        for db_user in cursor.fetchall():
            user_list.append({"userName": db_user[0],
                              "fullName": db_user[1],
                              "emailAddresses": db_user[2].split(",")})
        db_connection.close()
        return user_list

    def auth(self, username, password):
        db_connection = psycopg2.connect(host=self.db_host, user=self.db_user,
                                         password=self.db_pass, database=self.db_database)
        cursor = db_connection.cursor()
        cursor.execute('SELECT "userName","password" from users WHERE "userName" = %s AND "password" = %s', (username,
                                                                                                             password,))
        count = cursor.rowcount
        db_connection.close()
        return {"succeeded": count == 1}
